## ros-noetic-hector-gazebo-plugins 0.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(hector_gazebo_plugins VERSION 0.5.3)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS roscpp std_msgs std_srvs geographic_msgs geometry_msgs nav_msgs tf dynamic_reconfigure message_generation)
include_directories(include ${catkin_INCLUDE_DIRS})

## Find gazebo
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()
find_package(gazebo REQUIRED)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GAZEBO_CXX_FLAGS}")
include_directories(${GAZEBO_INCLUDE_DIRS})
link_directories(${GAZEBO_LIBRARY_DIRS})

## Find Boost
find_package(Boost REQUIRED COMPONENTS thread)
include_directories(${Boost_INCLUDE_DIRS})

#######################################
## Declare ROS messages and services ##
#######################################

## Generate messages in the 'msg' folder
# add_message_files(
#   FILES
# )

## Generate services in the 'srv' folder
add_service_files(DIRECTORY srv
  FILES
    SetBias.srv
    SetReferenceGeoPose.srv
)

## Generate added messages and services with any dependencies listed here
generate_messages(
  DEPENDENCIES geographic_msgs geometry_msgs
)

#add dynamic reconfigure api
generate_dynamic_reconfigure_options(
  cfg/SensorModel.cfg
  cfg/GNSS.cfg
)

###################################
## catkin specific configuration ##
###################################
## The catkin_package macro generates cmake config files for your package
## Declare things to be passed to dependent projects
## INCLUDE_DIRS: uncomment this if you package contains header files
## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package(
    CATKIN_DEPENDS roscpp std_msgs geographic_msgs geometry_msgs nav_msgs tf message_runtime
    INCLUDE_DIRS include
    LIBRARIES
)

###########
## Build ##
###########

add_library(diffdrive_plugin_6w src/diffdrive_plugin_6w.cpp)
target_link_libraries(diffdrive_plugin_6w ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(diffdrive_plugin_multi_wheel src/diffdrive_plugin_multi_wheel.cpp)
target_link_libraries(diffdrive_plugin_multi_wheel ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(gazebo_ros_force_based_move src/gazebo_ros_force_based_move.cpp)
target_link_libraries(gazebo_ros_force_based_move ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(hector_gazebo_reset_plugin src/reset_plugin.cpp)
target_link_libraries(hector_gazebo_reset_plugin ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

add_library(hector_gazebo_ros_imu src/gazebo_ros_imu.cpp)
target_link_libraries(hector_gazebo_ros_imu ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_imu ${PROJECT_NAME}_generate_messages_cpp ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_magnetic src/gazebo_ros_magnetic.cpp)
target_link_libraries(hector_gazebo_ros_magnetic ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_magnetic ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_gps src/gazebo_ros_gps.cpp)
target_link_libraries(hector_gazebo_ros_gps ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_gps ${PROJECT_NAME}_generate_messages_cpp ${PROJECT_NAME}_gencfg)

add_library(hector_gazebo_ros_sonar src/gazebo_ros_sonar.cpp)
target_link_libraries(hector_gazebo_ros_sonar ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})
add_dependencies(hector_gazebo_ros_sonar ${PROJECT_NAME}_gencfg)

add_library(hector_servo_plugin src/servo_plugin.cpp)
target_link_libraries(hector_servo_plugin ${Boost_LIBRARIES} ${GAZEBO_LIBRARIES} ${catkin_LIBRARIES})

#############
## Install ##
#############

# all install targets should use catkin DESTINATION variables
# See http://ros.org/doc/api/catkin/html/adv_user_guide/variables.html

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE
)

install(TARGETS
  diffdrive_plugin_6w
  diffdrive_plugin_multi_wheel
  gazebo_ros_force_based_move
  hector_gazebo_reset_plugin
  hector_gazebo_ros_imu
  hector_gazebo_ros_magnetic
  hector_gazebo_ros_gps
  hector_gazebo_ros_sonar
  hector_servo_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

=== debian/changelog ===
ros-noetic-hector-gazebo-plugins (0.5.4-1buster) buster; urgency=high

  * Added missing generate_message_cpp dependancy
  * Add service to gazebo gps sensor to set reference geopose
  * Add parameter to enable fetching the spherical coordinates from the world. (#83 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/83>)
    * Use worlds spherical_coordinates for GPS/magnetic reference
    This modifies GPS and magnetic plugins to use the values from the spherical_coordinates element of the world SDF as default values for the latitude, longitude, altitude and heading references.
    The optional parameters can still overwrite this values. However it is important to notice, that the heading in the world SDF is specified counter-clockwise from east whereas the reference_heading
    parameter is specified is specified clockwise from north.
    * Update spherical coordinates calls.
    * Add parameter to enable fetching the spherical coordinates from the world.
    This extends #47 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/47> with the addition of a "useWorldSphericalCoordinates" parameter
    that must be present and set to true to allow using the world's coordinates.
    This should solve #15 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/15> while addressing the concerns in #47 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/47>.
    Co-authored-by: Jacob Seibert <mailto:jacob.seibert@enway.ai>
  * Contributors: Ferry Schoenmakers, Roland Arsenault, h-wata

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Wed, 23 Jun 2021 00:00:00 -0000

ros-noetic-hector-gazebo-plugins (0.5.3-1buster) buster; urgency=high

  * Updated CMake version and fixed CMP0048 for non-metapackages.
  * Merge branch 'kinetic-devel' into melodic-devel
  * Adjust licenses to be consistent with cpp files and plugins used in gazebo_ros_pkgs
  * Updated package format and maintainer information.
  * Contributors: Stefan Fabian, Stefan Kohlbrecher

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Wed, 03 Feb 2021 00:00:00 -0000

ros-noetic-hector-gazebo-plugins (0.5.2-1buster) buster; urgency=high

  * Add case for rotating in place in odometry (#75 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/75>)
    * Add case for rotating in place in odometry
    Odometry calculations were not taking in account the case of the robot rotating in place. This
    would cause a division by zero and make the plugin return invalid data. This commit handles this
    case by not using the arc method if the distance traveled by the robot is close to zero.
    * Fix negative Y-axis motion bug
    Only the displacement along X and the combined displacement were used to
    calculate the angle between the X-axis and the robot drive direction.
    This resulted in a positive angle whatever if the displacement along Y
    was positive or negative. This commit addresses the issue by using both
    displacements along X and Y to calculate the angle.
  * Allow publishing sensor_msgs/MagneticField (#73 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/73>)
    Add a new useMagneticFieldMsgs parameter to the magnetometer plugin, allowing the node to publish sensor_msgs/MagneticField messages instead of std_msgs/Vector3Stamped
  * Add support of holonomic robot by adding missing Y component in odometry (#71 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/71>)
    * Add support of holonomic robot by adding missing Y component in odometry
    The odometry was only computed taking in account linear velocity on the x-axis and angular
    velocity around the z-axis. The code is modified to include linear velocity on the y-axis for
    support of holonomic robots. Odometry arc and radius are calculated the same way as before but
    using the combined linear velocity instead. The end position is then rotated by the angle between
    the combined velocity vector and the x-axis
    * Change variable name
    * Rename combined velocity angle variable
  * Merge pull request #64 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/64> from ms-iot/upstream_windows_fix
    [Windows][melodic-devel] Follow catkin guide to update the install path
  * fix install path. (#1 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/1>)
  * Merge pull request #53 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/53> from enwaytech/ml/cmp0054_fix
    add CMP0045 cmake policy before gazebo include in CMakeLists.txt
  * add CMP0045 cmake policy before gazebo include in CMakeLists.txt
  * Contributors: Chris I-B, Johannes Meyer, Matthias Loebach, RobinB, Sean Yen, Stefan Fabian

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Thu, 17 Dec 2020 00:00:00 -0000

ros-noetic-hector-gazebo-plugins (0.5.1-1buster) buster; urgency=high

  * Merge pull request #44 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/44> from esteve/gazebo8
    Use Gazebo 8 APIs to avoid deprecation warnings.
  * Fix indent
  * Depend on gazebo_dev instead
  * Use sdf::Time to read time periods from SDF files.
  * Only include math headers when building for Gazebo < 8
  * Use Gazebo 8 APIs to avoid deprecation warnings.
  * Merge pull request #36 <https://github.com/tu-darmstadt-ros-pkg/hector_gazebo/issues/36> from vincentrou/get_fix_status
    [gazebo_plugins] Ensure to get gps fix status as an int in urdf
  * hector_gazebo_plugins: numeric conversion of NavSatFix status and service from SDF without std::stoi
  * [gazebo_plugins] Ensure to get gps fix status as an int
  * hector_gazebo_plugins/hector_gazebo_thermal_camera: removed catkin_package(DEPENDS gazebo) declaration which was a no-op anyway
    See https://github.com/ros-simulation/gazebo_ros_pkgs/pull/537.
  * Contributors: Esteve Fernandez, Johannes Meyer, Vincent Rousseau

 -- Stefan Fabian <fabian@sim.tu-darmstadt.de>  Fri, 29 Jun 2018 00:00:00 -0000



=== debian/control ===
Source: ros-noetic-hector-gazebo-plugins
Section: misc
Priority: optional
Maintainer: Stefan Fabian <fabian@sim.tu-darmstadt.de>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-dynamic-reconfigure, ros-noetic-gazebo-dev, ros-noetic-geographic-msgs, ros-noetic-geometry-msgs, ros-noetic-message-generation, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf
Homepage: http://ros.org/wiki/hector_gazebo_plugins
Standards-Version: 3.9.2

Package: ros-noetic-hector-gazebo-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gazebo11, ros-noetic-dynamic-reconfigure, ros-noetic-gazebo-ros, ros-noetic-geographic-msgs, ros-noetic-geometry-msgs, ros-noetic-message-runtime, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf
Description: hector_gazebo_plugins provides gazebo plugins from Team Hector.
 Currently it contains a 6wd differential drive plugin, an IMU sensor plugin, an earth magnetic field sensor plugin, a GPS sensor plugin and a sonar ranger plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-hector-gazebo-plugins//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
